/*+-------------------------------------------------------------------+
  |                                                 iMAXhpMTFdet2.mq4 |
  |                                                                   |
  | MTF display application of the iMAXhp indicator with the          |
  | iMAXhp indicator itself built into the code.                      |
  |                                                                   |
  | This application is based upon kang_gun's                         |
  | iMAX MTF DETECTOR V1.1.mq4 Copyright  2009, KG                   |
  | Published by Forex TSD                                            |
  |                                                                   |
  | This indicator generates global variable values.                  |
  |                                                                   |
  | This indicator requires the stdlib.mqh file to exist in the       |
  | MT4 Terminal/experts/include folder (for error handling           |
  | associated with setting global variable values).                  |
  | The stdlib.mqh file is normally already in that folder...         |
  | unless it has been removed.                                       |
  |                                                                   |
  |                                         Crafted by "Wylie"        |
  |                                         Copyright  2009, "Wylie" |
  |                                         dazzle.html@live.com      |
  +-------------------------------------------------------------------+*/

#property copyright "Copyright  2009, Wylie"
#property link      "dazzle.html@live.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Aqua
#property indicator_color2  Red
#property indicator_width1  1
#property indicator_width2  1

#include   <stdlib.mqh>

extern int Corner           = 1;

int        MinBars;

double     iBuf0[],iBuf1[],Ph2step;

int        label_x_distance = 3,
           label_y_distance = 0,
           Flen             = 0,
           Lspc             = 12,
           per[10],c,err,dir;

string     Iname            = "iMAXhpDet",
           label[12],perStr[11],signLbl[10],sign;

color      Col;

/*+-------------------------------------------------------------------+
  | iMAXhp MTF Fast Trend Detector Initialization                     |
  +-------------------------------------------------------------------+*/

int init()
{
 IndicatorBuffers(2);

 // Index Buffer 0

 SetIndexBuffer(0,iBuf0);
 SetIndexShift(0,0);
 SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1,Aqua);

 // Index Buffer 1

 SetIndexBuffer(1,iBuf1);
 SetIndexShift(1,0);
 SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1,Red);

 MinBars = 20;

 switch(Period())
     {case PERIOD_M1:  Ph2step = 0.0001;  break;
      case PERIOD_M5:  Ph2step = 0.00015; break;
      case PERIOD_M15: Ph2step = 0.00030; break;
      case PERIOD_M30: Ph2step = 0.0006;  break;
      case PERIOD_H1:  Ph2step = 0.0012;  break;
      case PERIOD_H4:  Ph2step = 0.0024;  break;
      case PERIOD_D1:  Ph2step = 0.0048;  break;
      case PERIOD_W1:  Ph2step = 0.0084;  break;
      case PERIOD_MN1: Ph2step = 0.0168;  break;}

 IndicatorShortName("iMAXhp");

 perStr[1]  = "MN1";
 perStr[2]  = "W1";
 perStr[3]  = "D1";
 perStr[4]  = "H4";
 perStr[5]  = "H1";
 perStr[6]  = "M30";
 perStr[7]  = "M15";
 perStr[8]  = "M5";
 perStr[9]  = "M1";
 perStr[10] = "iMAXhp MTF";
 perStr[11] = "Fast Trend Detector 2";

 per[1]     = PERIOD_MN1;
 per[2]     = PERIOD_W1;
 per[3]     = PERIOD_D1;
 per[4]     = PERIOD_H4;
 per[5]     = PERIOD_H1;
 per[6]     = PERIOD_M30;
 per[7]     = PERIOD_M15;
 per[8]     = PERIOD_M5;
 per[9]     = PERIOD_M1;

 for(c = 1;c <= 11;c++)
    {Flen     = Flen + Lspc;
     label[c] = "iMAXhp_"+perStr[c];

 // Create timeframe labels
     ObjectCreate (label[c],OBJ_LABEL,0,0,0);
     ObjectSetText(label[c],perStr[c],8,"Arial Bold",Moccasin);
     ObjectSet    (label[c],OBJPROP_CORNER,Corner);
     ObjectSet    (label[c],OBJPROP_XDISTANCE,label_x_distance);
     ObjectSet    (label[c],OBJPROP_YDISTANCE,Flen+label_y_distance);}

 // Create title
 ObjectSet(label[10],OBJPROP_XDISTANCE,label_x_distance+17);
 ObjectSet(label[10],OBJPROP_YDISTANCE,Flen+Lspc+label_y_distance);
 Flen = Flen + Lspc;
 ObjectSet(label[11],OBJPROP_XDISTANCE,label_x_distance);
 ObjectSet(label[11],OBJPROP_YDISTANCE,Flen+Lspc+label_y_distance);

 return(0);
} // int init()

/*+-------------------------------------------------------------------+
  | iMAXhp MTF Fast Trend Detector Deinitialization                   |
  +-------------------------------------------------------------------+*/

int deinit()
{
 // Delete labels
 for(c = 1;c <= 11;c++)
     {ObjectDelete(label[c]);}

 // Delete arrows
 for(c = 1;c <= 10;c++)
     {ObjectDelete(Iname+" "+per[c]+" "+Symbol());}

 // Delete indicator "GO" object
 ObjectDelete(signLbl[10]);

 // Delete Global Variables
 for(c = 1;c <= 11;c++)
     {ObjectDelete(Iname+" "+perStr[c]);
      if(!GlobalVariableDel(Iname+" "+per[c]+" "+Symbol())){err=GetLastError();
         Print(Iname+" - Error GVsetInt() deinit(): "+perStr[c]+ErrorDescription(err));}}

 //Delete indicator "GO" global variable
 if(!GlobalVariableDel(Iname+"GO"+Symbol())){err=GetLastError();
     Print(Iname+" - Error GVsetInt() deinit(): iMAXhpDetGO ",ErrorDescription(err));}

 return(0);
} // int deinit()

/*+-------------------------------------------------------------------+
  | iMAXhp MTF Fast Trend Detector Main cycle                         |
  +-------------------------------------------------------------------+*/

int start()
{
 if(Bars <= MinBars){return (0);}

 int countedBars = IndicatorCounted();

 if(countedBars < 0){return (-1);}
 if(countedBars > 0){countedBars--;}

 int limit = Bars - countedBars - 1;
 double x  = 0.5;

 c = limit;

 while(c >= 0)
     {
      iBuf1[c] = (0.13785 * (2 * ((High[c]   + Low[c])   * x) - ((High[c+1] + Low[c+1]) * x)))
               + (0.0007  * (2 * ((High[c+1] + Low[c+1]) * x) - ((High[c+2] + Low[c+2]) * x)))
               + (0.13785 * (2 * ((High[c+2] + Low[c+2]) * x) - ((High[c+3] + Low[c+3]) * x)))
               + (1.2103  * iBuf1[c + 1] - 0.4867 * iBuf1[c + 2]); 

      if(Close[c] > iBuf1[c])
         {iBuf0[c] = iBuf1[c] + Ph2step;}

      if(Close[c] < iBuf1[c])
         {iBuf0[c] = iBuf1[c] - Ph2step;}

      c--;
     } // for(c = limit;c >= 0;c--)

 Flen = 0;

 for(c = 1;c <= 9;c++)
    {Flen = Flen + Lspc;

     // Read indicator values.
     double iMAXhp0=iCustom(NULL,per[c],"iMAXhp",0,0);
     double iMAXhp1=iCustom(NULL,per[c],"iMAXhp",1,0);

     // Calculate arrow type and color
     if(iMAXhp0 > iMAXhp1 && Close[0] > iMAXhp0){sign="";Col=Lime;         dir=1;} //Trend Up Strong
     if(iMAXhp0 > iMAXhp1 && Close[0] < iMAXhp0){sign="";Col=LightSeaGreen;dir=2;} //Trend Up Weak
     if(iMAXhp0 < iMAXhp1 && Close[0] < iMAXhp0){sign="";Col=Orange;       dir=3;} //Trend Down Strong
     if(iMAXhp0 < iMAXhp1 && Close[0] > iMAXhp0){sign="";Col=Red;          dir=4;} //Trend Down Weak
     if(iMAXhp0==iMAXhp1)                       {sign="[";Col=Yellow;       dir=5;} //Ranging   

     // Create arrow objects
     signLbl[c] = Iname+" "+perStr[c];

     ObjectDelete (signLbl[c]);
     ObjectCreate (signLbl[c],OBJ_LABEL,0,0,0);
     ObjectSetText(signLbl[c],sign,10,"Wingdings",Col);
     ObjectSet    (signLbl[c],OBJPROP_CORNER,Corner);
     ObjectSet    (signLbl[c],OBJPROP_XDISTANCE,label_x_distance+40);
     ObjectSet    (signLbl[c],OBJPROP_YDISTANCE,Flen+label_y_distance);

     // Set global variable values
     if(!GVsetInt(Iname+" "+per[c]+" "+Symbol(),dir))
        {err=GetLastError();
         Print(Iname+" - Error GVsetInt(): "+dir+" "+ErrorDescription(err));}
    } // for(c = 1;c <= 9;c++)

 // Check that global variable values are set for periods
 
 for(c = 9;c >= 1;c--)
     {if(GlobalVariableGet(Iname+" "+per[c]+" "+Symbol()) == 0)
         {break;}}

 // Detect global variable values set and preset indicator "GO" coloration
 if(c == 0)
    {Col = Aqua;
     if(!GVsetInt(Iname+"GO"+Symbol(),1))
        {err=GetLastError();
         Print(Iname+" - Error GVsetInt(): "+Iname+"GO"+" "+ErrorDescription(err));}}
 if(c != 0)
    {Col = Red;
     if(!GVsetInt(Iname+"GO"+Symbol(),0))
        {err=GetLastError();
         Print(Iname+" - Error GVsetInt(): "+Iname+"GO"+" "+ErrorDescription(err));}}

 // Create Indicator "GO" object
 Flen = Flen + Lspc;
 signLbl[10] = Iname+"GO";
 ObjectDelete (signLbl[10]);
 ObjectCreate (signLbl[10],OBJ_LABEL,0,0,0);
 ObjectSetText(signLbl[10],"",10,"Wingdings",Col);
 ObjectSet    (signLbl[10],OBJPROP_CORNER,Corner);
 ObjectSet    (signLbl[10],OBJPROP_XDISTANCE,label_x_distance+40);
 ObjectSet    (signLbl[10],OBJPROP_YDISTANCE,Flen+label_y_distance);

 return(0);
} // int start()

/*+-------------------------------------------------------------------+
  | End iMAXhp MTF Fast Trend Detector Main cycle                     |
  +-------------------------------------------------------------------+*/


/*+-------------------------------------------------------------------+
  | iMAXhp MTF Fast Trend Detector support functions                  |
  +-------------------------------------------------------------------+*/

/*+-------------------------------------------------------------------+
  | *** Set Global Variable value function                            |
  +-------------------------------------------------------------------+*/

bool GVsetInt(string a,int b)
{
 if(GlobalVariableSet(a,b) == 0)
    {return(false);}
 else
    {return(true);}

} // GVsetInt(string a,int b)

/*+-------------------------------------------------------------------+
  | End iMAXhp MTF Fast Trend Detector support functions              |
  +-------------------------------------------------------------------+*/

